﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Irony.Parsing;

namespace Demo
{
    public class FilterToken
    {
        Parser parser;
        FilterToken(Parser parser)
        {
            parser = this.parser;
        }

        public Token FilteringToken(ref int state)
        {
            Token Token = parser.Scanner.VsReadToken(ref state);
            return Token;
        }


        //#region Properties and Fields: Data, _source
        //public readonly ScannerData Data;
        //public readonly Parser Parser;
        //Irony.Parsing.Grammar _grammar;
        
        ////buffered tokens can come from expanding a multi-token, when Terminal.TryMatch() returns several tokens packed into one token

        //private ParsingContext Context1
        //{
        //    get { return Parser.Context; }
        //}
        //#endregion

        //public FilterToken(Parser parser)
        //{
        //    Parser = parser;
        //    Data = parser.Language.ScannerData;
        //    _grammar = parser.Language.Grammar;
        //    //create token streams
        //    var tokenStream = GetUnfilteredTokens();
        //    //chain all token filters
        //    Context1.TokenFilters.Clear();
        //    _grammar.CreateTokenFilters(Data.Language, Context1.TokenFilters);
        //    foreach (TokenFilter filter in Context1.TokenFilters)
        //    {
        //        tokenStream = filter.BeginFiltering(Context1, tokenStream);
        //    }
        //    Context1.FilteredTokens = tokenStream.GetEnumerator();
        //}

        //internal void Reset()
        //{
        //}

        //public Token GetToken()
        //{
        //    //get new token from pipeline
        //    if (!Context1.FilteredTokens.MoveNext()) return null;
        //    var token = Context1.FilteredTokens.Current;
        //    if (Context1.Status == ParserStatus.Previewing)
        //        Context1.PreviewTokens.Push(token);
        //    else
        //        Context1.CurrentParseTree.Tokens.Add(token);
        //    return token;
        //}


        //private IEnumerable<Token> GetUnfilteredTokens()
        //{
        //    //We don't do "while(!_source.EOF())... because on EOF() we need to continue and produce EOF token 
        //    while (true)
        //    {
        //        Context1.PreviousToken = Context1.CurrentToken;
        //        Context1.CurrentToken = null;
        //       // NextToken();
        //        Context1.OnTokenCreated();
        //        yield return Context1.CurrentToken;
        //        //Don't yield break, continue returning EOF
        //    }//while
        //}// method
        //#region Scanning tokens
      //  private void NextToken()
      //  {
      //      //1. Check if there are buffered tokens
      //      if (Context1.BufferedTokens.Count > 0)
      //      {
      //          Context1.CurrentToken = Context1.BufferedTokens.Pop();
      //          return;
      //      }
      //      //2. Skip whitespace.
      //    //  _grammar.SkipWhitespace(Context1.Source);
      //      //3. That's the token start, calc location (line and column)
      ////      Context1.Source.Position = Context1.Source.PreviewPosition;
      //      //4. Check for EOF
      //      if (Context1.Source.EOF())
      //      {
      //          Context1.CurrentToken = new Token(_grammar.Eof, Context1.Source.Location, string.Empty, _grammar.Eof.Name); ;
      //          return;
      //      }
      //      //5. Actually scan the source text and construct a new token
      //      ScanToken();
      //  }//method

        ////Scans the source text and constructs a new token
        //private void ScanToken()
        //{
        //    if (!MatchNonGrammarTerminals() && !MatchRegularTerminals())
        //    {
        //        //we are in error already; try to match ANY terminal and let the parser report an error
        //        MatchAllTerminals(); //try to match any terminal out there
        //    }
        //    var token = Context1.CurrentToken;
        //    //If we have normal token then return it
        //    if (token != null && !token.IsError())
        //    {
        //        var src = Context1.Source;
        //        //set position to point after the result token
        //        src.PreviewPosition = src.Position + token.Length;
        //        src.Position = src.PreviewPosition;
        //        return;
        //    }
        //    //we have an error: either error token or no token at all
        //    if (token == null)   //if no token then create error token
        //        Context1.CurrentToken = Context1.CreateErrorToken(Resources.ErrInvalidChar, Context1.Source.PreviewChar);
        //    Recover();
        //}

        //private bool MatchNonGrammarTerminals()
        //{
        //    TerminalList terms;
        //    if (!Data.NonGrammarTerminalsLookup.TryGetValue(Context1.Source.PreviewChar, out terms))
        //        return false;
        //    foreach (var term in terms)
        //    {
        //        Context1.Source.PreviewPosition = Context1.Source.Location.Position;
        //        Context1.CurrentToken = term.TryMatch(Context1, Context1.Source);
        //        if (Context1.CurrentToken != null)
        //            term.OnValidateToken(Context1);
        //        if (Context1.CurrentToken != null)
        //        {
        //            //check if we need to fire LineStart token before this token; 
        //            // we do it only if the token is not a comment; comments should be ignored by the outline logic
        //            var token = Context1.CurrentToken;
        //            if (token.Category == TokenCategory.Content && NeedLineStartToken(token.Location))
        //            {
        //                Context1.BufferedTokens.Push(token); //buffer current token; we'll eject LineStart instead
        //                Context1.Source.Location = token.Location; //set it back to the start of the token
        //                Context1.CurrentToken = Context1.Source.CreateToken(_grammar.LineStartTerminal); //generate LineStart
        //                Context1.PreviousLineStart = Context1.Source.Location; //update LineStart
        //            }
        //            return true;
        //        }//if
        //    }//foreach term
        //    Context1.Source.PreviewPosition = Context1.Source.Location.Position;
        //    return false;
        //}

        //private bool NeedLineStartToken(SourceLocation forLocation)
        //{
        //    return _grammar.LanguageFlags.IsSet(LanguageFlags.EmitLineStartToken) &&
        //        forLocation.Line > Context1.PreviousLineStart.Line;
        //}

        //private bool MatchRegularTerminals()
        //{
        //    //We need to eject LineStart BEFORE we try to produce a real token; this LineStart token should reach 
        //    // the parser, make it change the state and with it to change the set of expected tokens. So when we 
        //    // finally move to scan the real token, the expected terminal set is correct.
        //    if (NeedLineStartToken(Context1.Source.Location))
        //    {
        //        Context1.CurrentToken = Context1.Source.CreateToken(_grammar.LineStartTerminal);
        //        Context1.PreviousLineStart = Context1.Source.Location;
        //        return true;
        //    }
        //    //Find matching terminal
        //    // First, try terminals with explicit "first-char" prefixes, selected by current char in source
        //    ComputeCurrentTerminals();
        //    //If we have more than one candidate; let grammar method select
        //    if (Context1.CurrentTerminals.Count > 1)
        //        _grammar.OnScannerSelectTerminal(Context1);

        //    MatchTerminals();
        //    //If we don't have a token from terminals, try Grammar's method
        //    if (Context1.CurrentToken == null)
        //        Context1.CurrentToken = _grammar.TryMatch(Context1, Context1.Source);
        //    if (Context1.CurrentToken is MultiToken)
        //        UnpackMultiToken();
        //    return Context1.CurrentToken != null;
        //}//method

        //// This method is a last attempt by scanner to match ANY terminal, after regular matching (by input char) had failed.
        //// Likely this will produce some token which is invalid for current parser state (for ex, identifier where a number 
        //// is expected); in this case the parser will report an error as "Error: expected number".
        //// if this matching fails, the scanner will produce an error as "unexpected character."
        //private bool MatchAllTerminals()
        //{
        //    Context1.CurrentTerminals.Clear();
        //    Context1.CurrentTerminals.AddRange(Data.Language.GrammarData.Terminals);
        //    MatchTerminals();
        //    if (Context1.CurrentToken is MultiToken)
        //        UnpackMultiToken();
        //    return Context1.CurrentToken != null;
        //}

        ////If token is MultiToken then push all its child tokens into _bufferdTokens and return the first token in buffer
        //private void UnpackMultiToken()
        //{
        //    var mtoken = Context1.CurrentToken as MultiToken;
        //    if (mtoken == null) return;
        //    for (int i = mtoken.ChildTokens.Count - 1; i >= 0; i--)
        //        Context1.BufferedTokens.Push(mtoken.ChildTokens[i]);
        //    Context1.CurrentToken = Context1.BufferedTokens.Pop();
        //}

        //private void ComputeCurrentTerminals()
        //{
        //    Context1.CurrentTerminals.Clear();
        //    TerminalList termsForCurrentChar;
        //    if (!Data.TerminalsLookup.TryGetValue(Context1.Source.PreviewChar, out termsForCurrentChar))
        //        termsForCurrentChar = Data.NoPrefixTerminals;
        //    //if we are recovering, previewing or there's no parser state, then return list as is
        //    if (Context1.Status == ParserStatus.Recovering || Context1.Status == ParserStatus.Previewing
        //        || Context1.CurrentParserState == null || _grammar.LanguageFlags.IsSet(LanguageFlags.DisableScannerParserLink)
        //        || Context1.Mode == ParseMode.VsLineScan)
        //    {
        //        Context1.CurrentTerminals.AddRange(termsForCurrentChar);
        //        return;
        //    }
        //    // Try filtering terms by checking with parser which terms it expects; 
        //    var parserState = Context1.CurrentParserState;
        //    foreach (var term in termsForCurrentChar)
        //    {
        //        //Note that we check the OutputTerminal with parser, not the term itself;
        //        //in most cases it is the same as term, but not always
        //        if (parserState.ExpectedTerminals.Contains(term.OutputTerminal) || _grammar.NonGrammarTerminals.Contains(term))
        //            Context1.CurrentTerminals.Add(term);
        //    }

        //}//method

        //private void MatchTerminals()
        //{
        //    Token priorToken = null;
        //    for (int i = 0; i < Context1.CurrentTerminals.Count; i++)
        //    {
        //        var term = Context1.CurrentTerminals[i];
        //        // If we have priorToken from prior term in the list, check if prior term has higher priority than this term; 
        //        //  if term.Priority is lower then we don't need to check anymore, higher priority (in prior token) wins
        //        // Note that terminals in the list are sorted in descending priority order
        //        if (priorToken != null && priorToken.Terminal.Priority > term.Priority)
        //            return;
        //        //Reset source position and try to match
        //        Context1.Source.PreviewPosition = Context1.Source.Location.Position;
        //        var token = term.TryMatch(Context1, Context1.Source);
        //        if (token == null) continue;
        //        //skip it if it is shorter than previous token
        //        if (priorToken != null && !priorToken.IsError() && (token.Length < priorToken.Length))
        //            continue;
        //        Context1.CurrentToken = token; //now it becomes current token
        //        term.OnValidateToken(Context1); //validate it
        //        if (Context1.CurrentToken != null)
        //            priorToken = Context1.CurrentToken;
        //    }
        //}//method

        //#endregion

        //#region VS Integration methods
        ////Use this method for VS integration; VS language package requires scanner that returns tokens one-by-one. 
        //// Start and End positions required by this scanner may be derived from Token : 
        ////   start=token.Location.Position; end=start + token.Length;
        //public Token VsReadToken(ref int state)
        //{
        //    Context1.VsLineScanState.Value = state;
        //    if (Context1.Source.EOF()) return null;
        //    if (state == 0)
        //        NextToken();
        //    else
        //    {
        //        Terminal term = Data.MultilineTerminals[Context1.VsLineScanState.TerminalIndex - 1];
        //        Context1.CurrentToken = term.TryMatch(Context1, Context1.Source);
        //    }
        //    //set state value from context
        //    state = Context1.VsLineScanState.Value;
        //    if (Context1.CurrentToken != null && Context1.CurrentToken.Terminal == _grammar.Eof)
        //        return null;
        //    return Context1.CurrentToken;
        //}
        ////public void VsSetSource(string text, int offset)
        ////{
        ////    var line = Context1.Source == null ? 0 : Context1.Source.Location.Line;
        ////    var newLoc = new SourceLocation(offset, line + 1, 0);
        ////    Context1.Source = new SourceStream(text, Context1.Language.Grammar.CaseSensitive, Context1.TabWidth, newLoc);
        ////}
        //#endregion

        //#region Error recovery
        ////Simply skip until whitespace or delimiter character
        //private bool Recover()
        //{
        //    var src = Context1.Source;
        //    src.PreviewPosition++;
        //    while (!Context1.Source.EOF())
        //    {
        //        if (_grammar.IsWhitespaceOrDelimiter(src.PreviewChar))
        //        {
        //            src.Position = src.PreviewPosition;
        //            return true;
        //        }
        //        src.PreviewPosition++;
        //    }
        //    return false;
        //}
        //#endregion

       // #region TokenPreview
        //Preview mode allows custom code in grammar to help parser decide on appropriate action in case of conflict
        // Preview process is simply searching for particular tokens in "preview set", and finding out which of the 
        // tokens will come first.
        // In preview mode, tokens returned by FetchToken are collected in _previewTokens list; after finishing preview
        //  the scanner "rolls back" to original position - either by directly restoring the position, or moving the preview
        //  tokens into _bufferedTokens list, so that they will read again by parser in normal mode.
        //// See c# grammar sample for an example of using preview methods
        //SourceLocation _previewStartLocation;

        ////Switches Scanner into preview mode
        //public void BeginPreview()
        //{
        //    Context1.Status = ParserStatus.Previewing;
        //    _previewStartLocation = Context1.Source.Location;
        //    Context1.PreviewTokens.Clear();
        //}

        ////Ends preview mode
        //public void EndPreview(bool keepPreviewTokens)
        //{
        //    if (keepPreviewTokens)
        //    {
        //        //insert previewed tokens into buffered list, so we don't recreate them again
        //        while (Context1.PreviewTokens.Count > 0)
        //            Context1.BufferedTokens.Push(Context1.PreviewTokens.Pop());
        //    }
        //    else
        //        Context1.SetSourceLocation(_previewStartLocation);
        //    Context1.PreviewTokens.Clear();
        //    Context1.Status = ParserStatus.Parsing;
        //}
        //#endregion

    }
}
