/***************************************************************************

Copyright (c) Microsoft Corporation. All rights reserved.
This code is licensed under the Visual Studio SDK license terms.
THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.

***************************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.VisualStudio.TextManager.Interop;
using Microsoft.VisualStudio.Package;

namespace Demo
{
    public class Source : Microsoft.VisualStudio.Package.Source
    {
        public Source(LanguageService service, IVsTextLines textLines, Colorizer colorizer)
            : base(service, textLines, colorizer)
        {
        }
        public bool jack;
        private object parseResult;
        public object ParseResult
        {
            get { return parseResult; }
            set { parseResult = value; }
        }

        private IList<TextSpan[]> braces;
        public IList<TextSpan[]> Braces
        {
            get { return braces; }
            set { braces = value; }
        }
        public override void BeginParse()
        {
            base.BeginParse();
        }

        public override MethodData CreateMethodData()
        {
            MethodData s = base.CreateMethodData();
            return s;
        }
        public override void OnChangeLineText(TextLineChange[] lineChange, int last)
        {
            jack = true;
            base.OnChangeLineText(lineChange, last);
        }
        public override void MethodTip(IVsTextView textView, int line, int index, TokenInfo info)
        {
            base.MethodTip(textView, line, index, info);
        }
        public override void OnChangeLineAttributes(int firstLine, int lastLine)
        {
            base.OnChangeLineAttributes(firstLine, lastLine);
        }
        public override ParseRequest BeginParse(int line, int idx, TokenInfo info, ParseReason reason, IVsTextView view, ParseResultHandler callback)
        {
            ParseRequest parseRequest = null;
            //if (jack)
            //{
            //    jack = false;
            //    Completion(view, info, Microsoft.VisualStudio.Package.ParseReason.CompleteWord);
            //}

            parseRequest = base.BeginParse(line, idx, info, reason, view, callback);


            return parseRequest;
        }

        public override void Completion(IVsTextView textView, TokenInfo info, ParseReason reason)
        {
            base.Completion(textView, info, reason);
        }

        public override AuthoringSink CreateAuthoringSink(ParseReason reason, int line, int col)
        {
            AuthoringSink c = base.CreateAuthoringSink(reason, line, col);

            return c;
        }
        public override CompletionSet CreateCompletionSet()
        {
            CompletionSet c = base.CreateCompletionSet();
            return c;
        }
    }
}